package fr.username404.snowygui.config

import com.mojang.blaze3d.vertex.PoseStack
import fr.username404.snowygui.gui.FontUtil
import fr.username404.snowygui.gui.feature.Colors
import fr.username404.snowygui.gui.feature.riskyCheatsEnabled
import net.minecraft.client.gui.screens.Screen
import net.minecraft.network.chat.Component
import net.minecraft.network.chat.TranslatableComponent

private const val confPrefix: String = "screen.snowy.config"
private val translationComponent = TranslatableComponent(confPrefix)

var configScreenParent: Screen? = null

val SnowyConfigScreen: Screen get() {
    return try {
        Class.forName("me.shedaniel.clothconfig2.api.ConfigBuilder")
        me.shedaniel.clothconfig2.api.ConfigBuilder.create().setParentScreen(configScreenParent).transparentBackground()
            .setShouldListSmoothScroll(true)
            .setTitle(translationComponent).apply {
                with(entryBuilder()) {
                    getOrCreateCategory(TranslatableComponent("$confPrefix.general")).addEntry(
                        startBooleanToggle(Component.nullToEmpty("Risky Cheats"), riskyCheatsEnabled)
                            .requireRestart()
                            .setSaveConsumer {
                                riskyCheatsEnabled = it
                            }.build()
                    ).addEntry(startSubCategory(TranslatableComponent("$confPrefix.behavior")).build())
                }
            }.build()
    } catch (e: ClassNotFoundException) {
        object: Screen(translationComponent) {
            override fun isPauseScreen(): Boolean = false
            override fun render(poseStack: PoseStack?, i: Int, j: Int, f: Float) {
                super.renderBackground(poseStack)
                FontUtil.drawScaled(poseStack!!,
                    text = "An appropriate version of the Cloth Config mod is required for the configuration of snowygui.", 16.0, 16.0,
                    color = Colors.WHITE, scaleFactor = 0.85F
                )
            }
            override fun onClose() { minecraft?.screen = configScreenParent }
        }
    }
}